package
{
	import flash.display.*;
	import flash.text.*;
	import flash.events.*;
	import flash.ui.*;
	import flash.utils.*;
	
	[SWF(width="400", height="200", frameRate="30", backgroundColor="#FFFFFF")]
	
	public class KeyTester extends Sprite
	{
		private var _info:TextField = new TextField();
		private var _keys:TextField = new TextField();
		private var _ctrlDown:Boolean = false;
		private var _shiftDown:Boolean = false;
		private var _altDown:Boolean = false;
	
		public function KeyTester():void
		{
			init();
		}
		
		protected function onStageClick(evt:MouseEvent):void
		{
			var txt:String = "Ctrl key : "+evt.ctrlKey+" (should be "+_ctrlDown+")\n";
			txt += "Shift key : "+evt.shiftKey+" (should be "+_shiftDown+")\n";
			txt += "Alt key : "+evt.altKey+" (should be "+_altDown+")";
			
			_info.text = txt;
			
			_keys.appendText("Click ! (timer="+getTimer()+")\n");
			_keys.scrollV = _keys.maxScrollV;
		}
		
		protected function ctrlDown(evt:KeyboardEvent):void
		{
			if (evt.keyCode == Keyboard.CONTROL)
			{
				_keys.appendText("Control has been pressed\n");
				_ctrlDown = true;
			}
			else if (evt.keyCode == 18)
			{
				_keys.appendText("Alt has been pressed\n");
				_altDown = true;
			}
			else if (evt.keyCode == Keyboard.SHIFT)
			{
				_keys.appendText("Shift has been pressed\n");
				_shiftDown = true;
			}
			else
			{
				_keys.appendText("Another key ("+evt.keyCode+") has been pressed\n");
			}
			
			_keys.scrollV = _keys.maxScrollV;
		}
		
		protected function ctrlUp(evt:KeyboardEvent):void
		{
			if (evt.keyCode == Keyboard.CONTROL)
			{
				_keys.appendText("Control has been released\n");
				_ctrlDown = false;
			}
			else if (evt.keyCode == 18)
			{
				_keys.appendText("Alt has been released\n");
				_altDown = false;
			}
			else if (evt.keyCode == Keyboard.SHIFT)
			{
				_keys.appendText("Shift has been released\n");
				_shiftDown = false;
			}
			else
			{
				_keys.appendText("Another key ("+evt.keyCode+") has been released\n");
			}
			
			_keys.scrollV = _keys.maxScrollV;
		}
		
		private function init():void
		{
			var format:TextFormat = new TextFormat();
			format.font = "Arial";
			format.size = 12;
			
			_info.width = 200;
			_info.height = 60;
			_info.defaultTextFormat = format;
			_info.text = "Click on the screen and play\nwith ctrl, alt & shift...";
			addChild(_info);
			
			_keys.width = 200;
			_keys.height = 200;
			_keys.x = 200;
			_keys.defaultTextFormat = format;
			_keys.text = "";
			addChild(_keys);
			
			var g:Graphics = this.graphics;
			g.beginFill(0, 0.1);
			g.drawRect(0, 0, 400, 200);
			g.endFill();
			
			stage.addEventListener(MouseEvent.CLICK, onStageClick);
			stage.addEventListener(KeyboardEvent.KEY_DOWN, ctrlDown);
			stage.addEventListener(KeyboardEvent.KEY_UP, ctrlUp);
		}
	}
}
